Open CASCADE Technology: GeomPlate_Surface Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
GeomPlate_Surface Class Reference

Describes the characteristics of plate surface objects returned by BuildPlateSurface::Surface. These can be used to verify the quality of the resulting surface before approximating it to a Geom_BSpline surface generated by MakeApprox. This proves necessary in cases where you want to use the resulting surface as the support for a shape. The algorithmically generated surface cannot fill this function as is, and as a result must be converted first. More...

`#include <GeomPlate_Surface.hxx>`

Inheritance diagram for GeomPlate_Surface:
[legend]

## Public Member Functions
| GeomPlate_Surface (const Handle< Geom_Surface > &Surfinit, const Plate_Plate &Surfinter)
void | UReverse ()
| Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified. More...
Standard_Real | UReversedParameter (const Standard_Real U) const
| Return the parameter on the Ureversed surface for the point of parameter U on <me>. More...
void | VReverse ()
| Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified. More...
Standard_Real | VReversedParameter (const Standard_Real V) const
| Return the parameter on the Vreversed surface for the point of parameter V on <me>. More...
virtual void | TransformParameters (Standard_Real &U, Standard_Real &V, const gp_Trsf &T) const
| Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>. More...
virtual gp_GTrsf2d | ParametricTransformation (const gp_Trsf &T) const
| Returns a 2d transformation used to find the new parameters of a point on the transformed surface. More...
void | Bounds (Standard_Real &U1, Standard_Real &U2, Standard_Real &V1, Standard_Real &V2) const
| Returns the parametric bounds U1, U2, V1 and V2 of this surface. If the surface is infinite, this function can return a value equal to Precision::Infinite: instead of Standard_Real::LastReal. More...
Standard_Boolean | IsUClosed () const
| Is the surface closed in the parametric direction U ? Returns True if for each parameter V the distance between the point P (UFirst, V) and P (ULast, V) is lower or equal to Resolution from gp. UFirst and ULast are the parametric bounds in the U direction. More...
Standard_Boolean | IsVClosed () const
| Is the surface closed in the parametric direction V ? Returns True if for each parameter U the distance between the point P (U, VFirst) and P (U, VLast) is lower or equal to Resolution from gp. VFirst and VLast are the parametric bounds in the V direction. More...
Standard_Boolean | IsUPeriodic () const
| Is the parametrization of a surface periodic in the direction U ? It is possible only if the surface is closed in this parametric direction and if the following relation is satisfied : for each parameter V the distance between the point P (U, V) and the point P (U + T, V) is lower or equal to Resolution from package gp. T is the parametric period and must be a constant. More...
virtual Standard_Real | UPeriod () const
| returns the Uperiod. raises if the surface is not uperiodic. More...
Standard_Boolean | IsVPeriodic () const
| Is the parametrization of a surface periodic in the direction U ? It is possible only if the surface is closed in this parametric direction and if the following relation is satisfied : for each parameter V the distance between the point P (U, V) and the point P (U + T, V) is lower or equal to Resolution from package gp. T is the parametric period and must be a constant. More...
virtual Standard_Real | VPeriod () const
| returns the Vperiod. raises if the surface is not vperiodic. More...
Handle< Geom_Curve > | UIso (const Standard_Real U) const
| Computes the U isoparametric curve. More...
Handle< Geom_Curve > | VIso (const Standard_Real V) const
| Computes the V isoparametric curve. More...
GeomAbs_Shape | Continuity () const
| Global Continuity of the surface in direction U and V : C0 : only geometric continuity, C1 : continuity of the first derivative all along the surface, C2 : continuity of the second derivative all along the surface, C3 : continuity of the third derivative all along the surface, G1 : tangency continuity all along the surface, G2 : curvature continuity all along the surface, CN : the order of continuity is infinite. Example : If the surface is C1 in the V parametric direction and C2 in the U parametric direction Shape = C1. More...
Standard_Boolean | IsCNu (const Standard_Integer N) const
| Returns the order of continuity of the surface in the U parametric direction. Raised if N < 0. More...
Standard_Boolean | IsCNv (const Standard_Integer N) const
| Returns the order of continuity of the surface in the V parametric direction. Raised if N < 0. More...
void | D0 (const Standard_Real U, const Standard_Real V, gp_Pnt &P) const
| Computes the point of parameter U,V on the surface. More...
void | D1 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V) const
| Computes the point P and the first derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C1. More...
void | D2 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV) const
| Computes the point P, the first and the second derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C2. More...
void | D3 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV, gp_Vec &D3U, gp_Vec &D3V, gp_Vec &D3UUV, gp_Vec &D3UVV) const
| Computes the point P, the first,the second and the third derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C2. More...
gp_Vec | DN (const Standard_Real U, const Standard_Real V, const Standard_Integer Nu, const Standard_Integer Nv) const
| —Purpose ; Computes the derivative of order Nu in the direction U and Nv in the direction V at the point P(U, V). More...
Handle< Geom_Geometry > | Copy () const
| Creates a new object which is a copy of this geometric object. More...
void | Transform (const gp_Trsf &T)
| Transformation of a geometric object. This tansformation can be a translation, a rotation, a symmetry, a scaling or a complex transformation obtained by combination of the previous elementaries transformations. (see class Transformation of the package Geom). More...
Handle< Geom_Surface > | CallSurfinit () const
void | SetBounds (const Standard_Real Umin, const Standard_Real Umax, const Standard_Real Vmin, const Standard_Real Vmax)
void | RealBounds (Standard_Real &U1, Standard_Real &U2, Standard_Real &V1, Standard_Real &V2) const
void | Constraints (TColgp_SequenceOfXY &Seq) const
Public Member Functions inherited from Geom_Surface
Handle< Geom_Surface > | UReversed () const
| Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
Handle< Geom_Surface > | VReversed () const
| Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
gp_Pnt | Value (const Standard_Real U, const Standard_Real V) const
| Computes the point of parameter U on the surface. More...
Public Member Functions inherited from Geom_Geometry
void | Mirror (const gp_Pnt &P)
| Performs the symmetrical transformation of a Geometry with respect to the point P which is the center of the symmetry. More...
void | Mirror (const gp_Ax1 &A1)
| Performs the symmetrical transformation of a Geometry with respect to an axis placement which is the axis of the symmetry. More...
void | Mirror (const gp_Ax2 &A2)
| Performs the symmetrical transformation of a Geometry with respect to a plane. The axis placement A2 locates the plane of the symmetry : (Location, XDirection, YDirection). More...
void | Rotate (const gp_Ax1 &A1, const Standard_Real Ang)
| Rotates a Geometry. A1 is the axis of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt &P, const Standard_Real S)
| Scales a Geometry. S is the scaling value. More...
void | Translate (const gp_Vec &V)
| Translates a Geometry. V is the vector of the tanslation. More...
void | Translate (const gp_Pnt &P1, const gp_Pnt &P2)
| Translates a Geometry from the point P1 to the point P2. More...
Handle< Geom_Geometry > | Mirrored (const gp_Pnt &P) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax1 &A1) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax2 &A2) const
Handle< Geom_Geometry > | Rotated (const gp_Ax1 &A1, const Standard_Real Ang) const
Handle< Geom_Geometry > | Scaled (const gp_Pnt &P, const Standard_Real S) const
Handle< Geom_Geometry > | Transformed (const gp_Trsf &T) const
Handle< Geom_Geometry > | Translated (const gp_Vec &V) const
Handle< Geom_Geometry > | Translated (const gp_Pnt &P1, const gp_Pnt &P2) const
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Describes the characteristics of plate surface objects returned by BuildPlateSurface::Surface. These can be used to verify the quality of the resulting surface before approximating it to a Geom_BSpline surface generated by MakeApprox. This proves necessary in cases where you want to use the resulting surface as the support for a shape. The algorithmically generated surface cannot fill this function as is, and as a result must be converted first.

## Constructor & Destructor Documentation

GeomPlate_Surface::GeomPlate_Surface | ( | const Handle< Geom_Surface > & | Surfinit,
|  | const Plate_Plate & | Surfinter
| ) |  |

## Member Function Documentation

void GeomPlate_Surface::Bounds | ( | Standard_Real & | U1,
|  | Standard_Real & | U2,
|  | Standard_Real & | V1,
|  | Standard_Real & | V2
| ) |  | const
| virtual

Returns the parametric bounds U1, U2, V1 and V2 of this surface. If the surface is infinite, this function can return a value equal to Precision::Infinite: instead of Standard_Real::LastReal.

Implements Geom_Surface.

Handle< Geom_Surface > GeomPlate_Surface::CallSurfinit | ( |  | ) | const

void GeomPlate_Surface::Constraints | ( | TColgp_SequenceOfXY & | Seq | ) | const

GeomAbs_Shape GeomPlate_Surface::Continuity | ( |  | ) | const
| virtual

Global Continuity of the surface in direction U and V : C0 : only geometric continuity, C1 : continuity of the first derivative all along the surface, C2 : continuity of the second derivative all along the surface, C3 : continuity of the third derivative all along the surface, G1 : tangency continuity all along the surface, G2 : curvature continuity all along the surface, CN : the order of continuity is infinite. Example : If the surface is C1 in the V parametric direction and C2 in the U parametric direction Shape = C1.

Implements Geom_Surface.

Handle< Geom_Geometry > GeomPlate_Surface::Copy | ( |  | ) | const
| virtual

Creates a new object which is a copy of this geometric object.

Implements Geom_Geometry.

void GeomPlate_Surface::D0 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P
| ) |  | const
| virtual

Computes the point of parameter U,V on the surface.

Raised only for an "OffsetSurface" if it is not possible to compute the current point.

Implements Geom_Surface.

void GeomPlate_Surface::D1 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V
| ) |  | const
| virtual

Computes the point P and the first derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C1.

Implements Geom_Surface.

void GeomPlate_Surface::D2 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV
| ) |  | const
| virtual

Computes the point P, the first and the second derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C2.

Implements Geom_Surface.

void GeomPlate_Surface::D3 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV,
|  | gp_Vec & | D3U,
|  | gp_Vec & | D3V,
|  | gp_Vec & | D3UUV,
|  | gp_Vec & | D3UVV
| ) |  | const
| virtual

Computes the point P, the first,the second and the third derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C2.

Implements Geom_Surface.

gp_Vec GeomPlate_Surface::DN | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | Nu,
|  | const Standard_Integer | Nv
| ) |  | const
| virtual

—Purpose ; Computes the derivative of order Nu in the direction U and Nv in the direction V at the point P(U, V).

Raised if the continuity of the surface is not CNu in the U direction or not CNv in the V direction. Raised if Nu + Nv < 1 or Nu < 0 or Nv < 0.

Implements Geom_Surface.

Standard_Boolean GeomPlate_Surface::IsCNu | ( | const Standard_Integer | N | ) | const
| virtual

Returns the order of continuity of the surface in the U parametric direction. Raised if N < 0.

Implements Geom_Surface.

Standard_Boolean GeomPlate_Surface::IsCNv | ( | const Standard_Integer | N | ) | const
| virtual

Returns the order of continuity of the surface in the V parametric direction. Raised if N < 0.

Implements Geom_Surface.

Standard_Boolean GeomPlate_Surface::IsUClosed | ( |  | ) | const
| virtual

Is the surface closed in the parametric direction U ? Returns True if for each parameter V the distance between the point P (UFirst, V) and P (ULast, V) is lower or equal to Resolution from gp. UFirst and ULast are the parametric bounds in the U direction.

Implements Geom_Surface.

Standard_Boolean GeomPlate_Surface::IsUPeriodic | ( |  | ) | const
| virtual

Is the parametrization of a surface periodic in the direction U ? It is possible only if the surface is closed in this parametric direction and if the following relation is satisfied : for each parameter V the distance between the point P (U, V) and the point P (U + T, V) is lower or equal to Resolution from package gp. T is the parametric period and must be a constant.

Implements Geom_Surface.

Standard_Boolean GeomPlate_Surface::IsVClosed | ( |  | ) | const
| virtual

Is the surface closed in the parametric direction V ? Returns True if for each parameter U the distance between the point P (U, VFirst) and P (U, VLast) is lower or equal to Resolution from gp. VFirst and VLast are the parametric bounds in the V direction.

Implements Geom_Surface.

Standard_Boolean GeomPlate_Surface::IsVPeriodic | ( |  | ) | const
| virtual

Is the parametrization of a surface periodic in the direction U ? It is possible only if the surface is closed in this parametric direction and if the following relation is satisfied : for each parameter V the distance between the point P (U, V) and the point P (U + T, V) is lower or equal to Resolution from package gp. T is the parametric period and must be a constant.

Implements Geom_Surface.

virtual gp_GTrsf2d GeomPlate_Surface::ParametricTransformation | ( | const gp_Trsf & | T | ) | const
| virtual

Returns a 2d transformation used to find the new parameters of a point on the transformed surface.

me->Transformed(T)->Value(U',V')

is the same point as

me->Value(U,V).Transformed(T)

Where U',V' are obtained by transforming U,V with th 2d transformation returned by

me->ParametricTransformation(T)

This methods returns an identity transformation

It can be redefined. For example on the Plane, Cylinder, Cone, Revolved and Extruded surfaces.

Reimplemented from Geom_Surface.

void GeomPlate_Surface::RealBounds | ( | Standard_Real & | U1,
|  | Standard_Real & | U2,
|  | Standard_Real & | V1,
|  | Standard_Real & | V2
| ) |  | const

void GeomPlate_Surface::SetBounds | ( | const Standard_Real | Umin,
|  | const Standard_Real | Umax,
|  | const Standard_Real | Vmin,
|  | const Standard_Real | Vmax
| ) |  |

void GeomPlate_Surface::Transform | ( | const gp_Trsf & | T | ) |
| virtual

Transformation of a geometric object. This tansformation can be a translation, a rotation, a symmetry, a scaling or a complex transformation obtained by combination of the previous elementaries transformations. (see class Transformation of the package Geom).

Implements Geom_Geometry.

virtual void GeomPlate_Surface::TransformParameters | ( | Standard_Real & | U,
|  | Standard_Real & | V,
|  | const gp_Trsf & | T
| ) |  | const
| virtual

Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>.

me->Transformed(T)->Value(U',V')

is the same point as

me->Value(U,V).Transformed(T)

Where U',V' are the new values of U,V after calling

me->TranformParameters(U,V,T)

This methods does not change <U> and <V>

It can be redefined. For example on the Plane, Cylinder, Cone, Revolved and Extruded surfaces.

Reimplemented from Geom_Surface.

Handle< Geom_Curve > GeomPlate_Surface::UIso | ( | const Standard_Real | U | ) | const
| virtual

Computes the U isoparametric curve.

Implements Geom_Surface.

virtual Standard_Real GeomPlate_Surface::UPeriod | ( |  | ) | const
| virtual

returns the Uperiod. raises if the surface is not uperiodic.

Reimplemented from Geom_Surface.

void GeomPlate_Surface::UReverse | ( |  | ) |
| virtual

Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified.

Implements Geom_Surface.

Standard_Real GeomPlate_Surface::UReversedParameter | ( | const Standard_Real | U | ) | const
| virtual

Return the parameter on the Ureversed surface for the point of parameter U on <me>.

me->UReversed()->Value(me->UReversedParameter(U),V)

is the same point as

me->Value(U,V)

Implements Geom_Surface.

Handle< Geom_Curve > GeomPlate_Surface::VIso | ( | const Standard_Real | V | ) | const
| virtual

Computes the V isoparametric curve.

Implements Geom_Surface.

virtual Standard_Real GeomPlate_Surface::VPeriod | ( |  | ) | const
| virtual

returns the Vperiod. raises if the surface is not vperiodic.

Reimplemented from Geom_Surface.

void GeomPlate_Surface::VReverse | ( |  | ) |
| virtual

Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified.

Implements Geom_Surface.

Standard_Real GeomPlate_Surface::VReversedParameter | ( | const Standard_Real | V | ) | const
| virtual

Return the parameter on the Vreversed surface for the point of parameter V on <me>.

me->VReversed()->Value(U,me->VReversedParameter(V))

is the same point as

me->Value(U,V)

Implements Geom_Surface.

The documentation for this class was generated from the following file:

- GeomPlate_Surface.hxx